//The abilities script file. Custom things the character can do.

freeslot("S_PLAY_AIRFIRE1", "S_PLAY_AIRFIRE2", "MT_JETPACK", "S_JETFLY1", "S_JETFLY2", "S_JETIDLE", "S_PLAY_THINK") //I need this to set and check for states and more
freeslot("sfx_popsco", "sfx_popgin", "sfx_poptel", "sfx_popjet","sfx_selsco", "sfx_selgin", "sfx_seltel", "sfx_seljet", "sfx_scomov", "sfx_scoacc", "sfx_scostd"
, "sfx_gininv", "sfx_ginrtn", "sfx_telas", "sfx_telae", "sfx_telbs", "sfx_telbe", "sfx_telcs", "sfx_telce", "sfx_telds", "sfx_telde", "sfx_teles", "sfx_telee") //I NEED THIS
freeslot(
	"MT_INVERTER", 
	"SPR_INV1",
	"SPR_INV2",
	"S_INVERTUP1",
	"S_INVERTDOWN1",
	"S_INVERTUP2",
	"S_INVERTDOWN2",
	"S_INVERTUP3",
	"S_INVERTDOWN3",
	"S_GDOWN",
	"S_GUP",
	"S_SCOOTER_STAND",
	"S_SCOOTER_PAIN",
	"S_SCOOTER_RUN",
	"S_SCOOTER_JUMP",
	"S_PLAY_TPSTART1",
	"S_PLAY_TPEND1",
	"S_PLAY_TPSTART2",
	"S_PLAY_TPEND2",
	"S_PLAY_TPSTART3",
	"S_PLAY_TPEND3",
	"S_PLAY_TPSTART4",
	"S_PLAY_TPEND4",
	"S_PLAY_TPSTART5",
	"S_PLAY_TPEND5",
	"S_JETPACKIDLE",
	"S_JETPACKFLY1",
	"S_JETPACKFLY2",
	"S_SCOOTER_BYE1",
	"S_SCOOTER_BYE2"
)
//These freeslots are for script cuz Lua loads first and not SOC

local tpstart = {  //Some tables
S_PLAY_TPSTART1, S_PLAY_TPSTART2,
S_PLAY_TPSTART3, S_PLAY_TPSTART4,
S_PLAY_TPSTART5}

local tpend = {
S_PLAY_TPEND1, S_PLAY_TPEND2,
S_PLAY_TPEND3, S_PLAY_TPEND4,
S_PLAY_TPEND5}

local itemsounds = {
sfx_popsco, sfx_popjet,
sfx_poptel, sfx_popgin}

local starpostList = {}

local function ClearStarposts()//Starpost Tp Stuff
	starpostList = {}
end

local skymapList = {}

local function ClearSkymap()//Starpost Tp Stuff
	skymapList = {}
end

//add starposts to our list when they're spawned!
local function AddStarpost(mo)
	if not (mo.valid) then
		return
	end
	
	table.insert(starpostList, mo)
end

addHook("MapThingSpawn", AddStarpost, MT_STARPOST)

local function RemoveStarpost(mo)
	for k,v in ipairs(starpostList) do
		if (v == mo) then
			table.remove(starpostList, k)
		end
	end
end

addHook("MobjRemoved", RemoveStarpost, MT_STARPOST)

local function AddSkymap(mo)
	if not (mo.valid) then
		return
	end
	
	table.insert(skymapList, mo)
end

addHook("MapThingSpawn", AddSkymap, MT_SKYBOX)

local function RemoveSkymap(mo)
	for k,v in ipairs(skymapList) do
		if (v == mo) then
			table.remove(skymapList, k)
		end
	end
end

addHook("MobjRemoved", RemoveSkymap, MT_SKYBOX)

freeslot("sfx_jetfly", "sfx_jetlod", "sfx_jetfal")//Another sound freeslot for Jetpack

local function WaterRunCheck(player)
	local waterBlock = player.mo.floorrover

	if (player.mo.eflags & MFE_VERTICALFLIP) then
		waterBlock = player.mo.ceilingrover
	end

	if (waterBlock) then
		return P_CanRunOnWater(player, waterBlock)
	end
end

local function HenryBoostEffect(player)
	//boost
	if not (leveltime % 5) then
		local boostAngle = R_PointToAngle2(0, 0, -player.mo.momx, -player.mo.momy)
				
		if not (boostAngle) then return end
				
				
		local x = player.mo.x + FixedMul(cos(boostAngle), -player.mo.radius)
		local y = player.mo.y + FixedMul(sin(boostAngle), -player.mo.radius)
				
		for rot=-1,1,2 do
			for i=-1,1,1 do
				//local line = P_SPMAngle(player.mo, MT_HENRY_BOOST, boostAngle+ANG15*rot)
				local lineX = x + FixedMul(cos(boostAngle+ANGLE_90), 8*player.mo.scale*rot)
				local lineY = y + FixedMul(sin(boostAngle+ANGLE_90), 8*player.mo.scale*rot)
						
				local line = P_SpawnMobj(lineX, lineY, player.mo.z+(player.mo.height/2)+(i*player.mo.height/4), MT_HENRY_BOOST)
				line.scale = player.mo.scale
				line.type = MT_GHOST
				line.color = SKINCOLOR_TEAL
				line.colorized = true
				line.angle = boostAngle+ANG30*rot
				P_Thrust(line, line.angle, 15*line.scale)
						
				line.frame = $1|TR_TRANS40
				line.fuse = 9
			end
		end
	end
end

local function CheckAndCrumble(mo, sec)
  for fof in sec.ffloors()
    if not (fof.flags & FF_EXISTS) continue end
    if not (fof.flags & FF_BUSTUP) continue end 
    
    if mo.z + mo.height < fof.bottomheight continue end
    if mo.z > fof.topheight continue end 

    EV_CrumbleChain(fof) -- Crumble
  end
end

addHook("MobjLineCollide", function(mo, line)
  if not mo.player return end
  if (mo.skin != "henry") return end
   if (mo.player.jetpack != true) return end

  for _, sec in ipairs({line.frontsector, line.backsector})
    CheckAndCrumble(mo, sec)
  end
end, MT_PLAYER)

local function ClearG(player)
					player.jetpack = false
					player.scooter = false
					player.teleporter = false
					if P_IsObjectOnGround(player.mo)
					and player.invg == false
						player.ginv = false
						player.invg = false
					end
					player.normalspeed = skins[player.mo.skin].normalspeed
					player.runspeed = skins[player.mo.skin].runspeed
					player.charability = CA_NONE
					player.jumpfactor = skins[player.mo.skin].jumpfactor
					//player.followitem = MT_NULL
					if player.mo.state == S_SCOOTER_RUN
						if player.speed >= player.runspeed
							player.mo.state = S_PLAY_RUN
						else
							player.mo.state = S_PLAY_WALK
						end
					end
					if player.mo.state == S_SCOOTER_PAIN
						player.mo.state = S_PLAY_PAIN
					end
					if player.mo.state == S_SCOOTER_STAND
						player.mo.state = S_PLAY_STND
					end
					if player.mo.state == S_SCOOTER_JUMP
						player.mo.state = S_PLAY_JUMP
					end
end

local function G_Jetpack(player)
					player.jetpack = true
					player.scooter = false
					player.teleporter = false
					player.ginv = false
					player.invg = false
					if player.mo.state == S_SCOOTER_RUN
						if player.speed >= player.runspeed
							player.mo.state = S_PLAY_RUN
						else
							player.mo.state = S_PLAY_WALK
						end
					end
					if player.mo.state == S_SCOOTER_PAIN
						player.mo.state = S_PLAY_PAIN
					end
					if player.mo.state == S_SCOOTER_STAND
						player.mo.state = S_PLAY_STND
					end
					if player.mo.state == S_SCOOTER_JUMP
						player.mo.state = S_PLAY_JUMP
					end
end

local function G_Scooter(player)
					player.jetpack = false
					player.scooter = true
					player.teleporter = false
					player.ginv = false
					player.invg = false
end

local function G_Teleporter(player)
					player.jetpack = false
					player.scooter = false
					player.teleporter = true
					player.ginv = false
					player.invg = false
					player.normalspeed = skins[player.mo.skin].normalspeed
					player.runspeed = skins[player.mo.skin].runspeed
					player.charability = CA_NONE
					player.jumpfactor = skins[player.mo.skin].jumpfactor
end

local function G_Inverter(player)
					player.jetpack = false
					player.scooter = false
					player.teleporter = false
					player.ginv = true
					player.invg = false
					player.normalspeed = skins[player.mo.skin].normalspeed
					player.runspeed = skins[player.mo.skin].runspeed
					player.charability = CA_NONE
					player.jumpfactor = skins[player.mo.skin].jumpfactor
end

addHook("AbilitySpecial", function(player) //Jet pack`s ability
	if player.mo and player.mo.valid and player.mo.skin == "henry"
	and player.playerstate == PST_LIVE and not (player.powers[pw_carry] == CR_NIGHTSMODE)
		if player.jetpack == true
			/*if player.jetboost > 0
				if player.mo.eflags & MFE_UNDERWATER
					P_SetObjectMomZ(player.mo, 1*FRACUNIT/2, false)
				else
					P_SetObjectMomZ(player.mo, 1*FRACUNIT, false)
				end	
				S_StartSound(player.mo, sfx_jetfly)
				player.flyjet = 15
			end
			if player.jetboost <= 0
				S_StartSound(player.mo, sfx_jetlod)
				player.nope = 15
				player.pflags = $|PF_THOKKED
			end
			if player.jetboost > 0
				P_SpawnParaloop(jetpack.x,jetpack.y,jetpack.z,player.mo.scale*64,12,MT_DUST,ANGLE_90,nil,true)
				if P_RandomRange(1, 100) <= 40
					S_StartSound(player.mo, sfx_jetlod)
					player.nope = 15
					player.mo.state = S_PLAY_FALL
					player.failjet = true
					player.pflags = $|PF_THOKKED
					P_SetObjectMomZ(player.mo, 0*FRACUNIT)
				end 
			end
			player.jetboost = $1 - 1*/
			if not (player.pflags & PF_THOKKED)
				player.pflags = $|PF_THOKKED
				if P_RandomRange(1, 100) <= 40
					player.randomfail = P_RandomRange(1, 60)
					P_SpawnParaloop(player.mo.x,player.mo.y,player.mo.z,player.mo.scale*64,12,MT_DUST,ANGLE_90,nil,true)
				else
					player.randomfail = 0
				end	
			end	
		end
	end
end)
addHook("PlayerThink", function(player) //Main Henry`s thinker
	local jetpack
	local airmomz = 0
	if player.airmomz == nil
		player.aimmomz = player.mo.momz
	end
	if player.flyjet == nil
		player.flyjet = -1
	end	
	if player.stopstate == nil
		player.stopstate = false
	end
	if player.flyjet >= 0 //States and shit after using jet boost
	and not P_IsObjectOnGround(player.mo)
		player.flyjet = $1 - 1
		if player.flyjet <= 0
			if not S_SoundPlaying(player.mo, sfx_jetfal)
				S_StartSound(player.mo, sfx_jetfal)
			end
		end
	end
	if player.ishenry == nil
		player.ishenry = true
	end
	if player.jetboost == nil
		player.jetboost = 70
	end	
	if player.nope == nil
		player.nope = 0
	end
	if player.mo.skin != "henry"
		player.ishenry = true
	end
	local randomtpstate = P_RandomRange(1, 5) //Randoms
	local randomtptype = P_RandomRange(1, 3) 
	if player.mo and player.mo.valid and player.mo.skin == "henry"  //Some more henry shit
	and player.playerstate == PST_LIVE and not (player.powers[pw_carry] == CR_NIGHTSMODE)
		player.ishenry = true
		if player.milnekick
			P_PlayJingleMusic(player, "HKICK", nil, true, JT_OTHER)
		end
		if player.randomfail == nil
			player.randomfail = 1
		end
		if player.failjet == nil
			player.failjet = false
		end
		if player.failjet == true
			player.jetboost = 0
			if player.mo.state == S_PLAY_FALL
				player.mo.rollangle = $1 + player.mo.momz/FRACUNIT*ANG1
			else
				if player.mo.rollangle != 0
					player.mo.rollangle = 0
					player.failjet = false
				end
			end
		end
		if P_IsObjectOnGround(player.mo) //Jetpack shit still
			if player.nope <= 0
				player.jetboost = 70
			end	
			player.failjet = false
		end
		if player.mo.state == S_PLAY_FIRE or player.mo.state == S_PLAY_FIRE_FINISH or player.mo.state == S_PLAY_AIRFIRE1 or player.mo.state == S_PLAY_AIRFIRE2
			player.pflags = $|PF_FULLSTASIS
		end	//Stasis when in these states
		if player.deathfly == nil
			player.deathfly = 0
		end	
		if player.item == nil
			player.item = 0
		end
		if player.invg == nil
			player.invg = false
		end	
		if player.ginv == nil
			player.ginv = false
		end
		if player.aimangle == nil
			player.aimangle = player.mo.angle
		end
		if player.aimangle2 == nil
			player.aimangle2 = player.aiming
		end
		if player.gadgetbox == true //Gadget box shit(like switching)
		and not G_EnoughPlayersFinished()
			player.mo.angle = player.aimangle
			player.drawangle = player.aimangle
			player.aiming = player.aimangle2
			player.mo.momx = 0
			player.mo.momy = 0
			player.mo.momz = 0
			player.jumpfactor = 0
			if player.mo.state != S_PLAY_THINK
				player.mo.state = S_PLAY_THINK
			end
			S_FadeMusic(0, 1, player)
			player.item = $1 + 1
			if P_PlayerInPain(player)
				player.gadgetbox = false
				player.jumpfactor = skins[player.mo.skin].jumpfactor
				S_FadeMusic(100, 1, player)
			end
			if player.item >= 65
				if player.cmd.buttons & BT_JUMP
					if player.cmd.sidemove < -35
						if player.jetpack == false
							player.jetpack = true
							player.teleporter = false
							player.ginv = false
							player.invg = false
							player.scooter = false
							S_StartSound(player.mo, sfx_seljet, player)
						else
							player.jetpack = false
						end
						S_FadeMusic(100, 1, player)
						player.gadgetbox = false
						player.mo.state = S_PLAY_STND
						player.jumpfactor = skins[player.mo.skin].jumpfactor
						player.left = true
					else
						player.left = false	
					end
					if player.cmd.sidemove > 35
						if player.ginv == false
							player.ginv = true
							player.jetpack = false
							player.teleporter = false
							player.scooter = false
							S_StartSound(player.mo, sfx_selgin, player)
						else
							player.ginv = false
						end
						S_FadeMusic(100, 1, player)
						player.gadgetbox = false
						player.mo.state = S_PLAY_STND
						player.jumpfactor = skins[player.mo.skin].jumpfactor
						player.right = true
					else
						player.right = false	
					end
					if player.cmd.forwardmove < -35
						if player.teleporter == false
							if player.abletele == true
								player.teleporter = true
								player.jetpack = false
								player.scooter = false
								player.ginv = false
								player.invg = false
								S_StartSound(player.mo, sfx_seltel, player)
							else
								S_StartSound(player.mo, sfx_notadd, player)
							end	
						else
							player.teleporter = false
						end
						S_FadeMusic(100, 1, player)
						player.gadgetbox = false
						player.mo.state = S_PLAY_STND
						player.jumpfactor = skins[player.mo.skin].jumpfactor
						player.down = true
					else
						player.down = false	
					end
					if player.cmd.forwardmove > 35
						if player.scooter == false
							player.scooter = true
							player.jetpack = false
							player.teleporter = false
							player.ginv = false
							player.invg = false
							S_StartSound(player.mo, sfx_selsco, player)
						else
							player.scooter = false
						end
						S_FadeMusic(100, 1, player)
						player.gadgetbox = false
						player.mo.state = S_PLAY_STND
						player.jumpfactor = skins[player.mo.skin].jumpfactor
						player.up = true
					else
						player.up = false
					end
				end	
			end
		else
			player.item = 0
		end
		if player.item == 15 //Item sounds when appearing
			S_StartSound(player.mo, sfx_popsco, player)
		elseif player.item == 30
			S_StartSound(player.mo, sfx_popjet, player)
		elseif player.item == 45
			S_StartSound(player.mo, sfx_poptel, player)
		elseif player.item == 60
			S_StartSound(player.mo, sfx_popgin, player)	
		end	
		if player.gadgetbox == nil
			player.gadgetbox = false
		end	
		if player.jetpack == nil
			player.jetpack = false
		end
		if player.scooter == nil
			player.scooter = false
		end
		if player.teleporter == nil
			player.teleporter = false
		end
				if player.cmd.buttons & BT_JUMP
					if player.pflags & PF_JUMPED
					and not P_IsObjectOnGround(player.mo)
					and (player.pflags & PF_THOKKED)
						if player.jetpack == true
							//print(player.jetboost, player.randomfail)
							player.pflags = $|PF_CANCARRY
							if player.jetboost <= 0
							and player.failjet != true
								S_StartSound(player.mo, sfx_jetlod)
								player.nope = 15
								player.failjet = true
							end
							if player.jetboost > 0
								//P_SpawnParaloop(jetpack.x,jetpack.y,jetpack.z,player.mo.scale*64,12,MT_DUST,ANGLE_90,nil,true)
								if (leveltime%10) <= 5
									local ns = P_RandomRange(0, 360)*ANG1
									local dust = P_SpawnMobj(player.mo.x, player.mo.y, player.mo.z, MT_DUST)
									if player.mo.momz > 0
										P_SetObjectMomZ(dust, -player.mo.momz)
									else
										P_SetObjectMomZ(dust, player.mo.momz)
									end	
									P_InstaThrust(dust, ns, 5*FRACUNIT)
									dust.scale = P_RandomRange(1/2, 2)*FRACUNIT
									if player.mo.eflags & MFE_UNDERWATER
										dust.state = S_SPINDUST_BUBBLE1
									else
										if P_RandomRange(1, 10) <= 7
											dust.state = S_SPINDUST_FIRE1
										else
											dust.state = mobjinfo[dust.type].spawnstate
										end
									end
								end
								if player.randomfail == player.jetboost
								and player.failjet != true
									if not P_IsObjectOnGround(player.mo)
										S_StartSound(player.mo, sfx_jetfal)
										player.nope = 15
										player.mo.state = S_PLAY_FALL
										player.failjet = true
									end
								else
									if player.failjet != true
										if player.mo.eflags & MFE_UNDERWATER
											P_SetObjectMomZ(player.mo, (1*FRACUNIT - FRACUNIT/5)/2, true)
										else
											P_SetObjectMomZ(player.mo, 1*FRACUNIT - FRACUNIT/5, true)
										end	
										player.mo.state = S_PLAY_FLY
										if not (player.jetboost <= player.randomfail+15)
											if not S_SoundPlaying(player.mo, sfx_jetfly)
												S_StartSound(player.mo, sfx_jetfly)
											end	
										end	
										player.flyjet = 15
									else
										player.nope = 15
										player.failjet = true
									end	
								end 
							end
							player.jetboost = $1 - 1
						end
					end
					player.jumpjet = true
				else
					player.jumpjet = false
				end
		if player.jetpack == true //Jet pack stactics
		and not G_EnoughPlayersFinished()
			player.normalspeed = 20*FRACUNIT
			player.runspeed = 30*FRACUNIT
			CheckAndCrumble(player.mo, player.mo.subsector.sector)
			if player.hasjet != true
				jetpack = P_SpawnMobj(player.mo.x, player.mo.y, player.mo.z, MT_JETPACK)
				jetpack.jetpacker = player.mo
				player.hasjet = true
				if jetpack
					jetpack.rollangle = player.mo.rollangle
				end
				if not P_IsObjectOnGround(player.mo)
					if player.nope == 0 or player.jetboost >= player.randomfail
						jetpack.colorized = false
						jetpack.color = player.mo.color
					end	
				end
				if player.jetboost <= player.randomfail+15
				and player.failjet != true
				and not P_IsObjectOnGround(player.mo)
					if jetpack
						if not S_SoundPlaying(jetpack, sfx_jetfal)
							S_StartSound(jetpack, sfx_jetfal)
						end	
						if (leveltime%10) == 1
							local exp = P_SpawnMobj(jetpack.x, jetpack.y, jetpack.z+jetpack.height/2, MT_EXPLODE)
							exp.jetpacker = jetpack
							S_StartSound(exp, sfx_cybdth)
						end	
					end	
				end
				if player.nope > 0 //Flashing after unsecsesful jet boost
					player.nope = $1 - 1
					if jetpack
						if (leveltime%5) <= 2
							jetpack.colorized = true
							jetpack.color = SKINCOLOR_RED
						else
							jetpack.colorized = false
							jetpack.color = player.mo.color
						end
					end	
				end
			end
		else
			if player.hasjet == true
				player.hasjet = false
				if jetpack
					P_KillMobj(jetpack)
				end
			end
		end

		if player.scooter == true //Scooter stactics
		and not G_EnoughPlayersFinished()
			player.normalspeed = skins["sonic"].normalspeed
			player.runspeed = 30*FRACUNIT
			player.jumpfactor = skins["knuckles"].jumpfactor
			player.charflags = $|SF_RUNONWATER
			if player.speed >= player.runspeed
				player.charflags = $|SF_CANBUSTWALLS
			end
			if player.mo.chancetime > 0
				player.mo.chancetime = $ - 1
				player.powers[pw_sneakers] = 2
				if (leveltime%5) == 2
					local ghost = P_SpawnGhostMobj(player.mo)
					ghost.color = SKINCOLOR_BLUE
					ghost.colorized = true
					ghost.fuse = 4
				end	
				HenryBoostEffect(player) //By Rem(old scripter)
			end
			if P_IsObjectOnGround(player.mo)
				if player.speed == 0
					player.ableacc = true
				end
				if player.speed > 0
					if WaterRunCheck(player) == true
						player.mo.state = S_SCOOTER_PAIN
					else
						if player.chancetime and player.chancetime > 0
							player.mo.state = S_SCOOTER_PAIN
						else
							if player.mo.state != S_SCOOTER_RUN
								player.mo.state = S_SCOOTER_RUN
							end
						end	
					end	
				else
					if player.mo.state != S_SCOOTER_STAND
						player.mo.state = S_SCOOTER_STAND
					end
				end	
				if player.mo.state == S_PLAY_PAIN or player.pflags & PF_SLIDING
					player.mo.state = S_SCOOTER_PAIN
				end
			else
				if player.mo.state == S_PLAY_PAIN or player.pflags & PF_SLIDING
					player.mo.state = S_SCOOTER_PAIN
				end
				if not P_IsObjectOnGround(player.mo)
					player.mo.state = S_SCOOTER_JUMP
				end
			end	
		end 
		if player.gadgetboxt == nil
			player.gadgetboxt = 0
		end	
		if player.gadgetboxt > 0
			player.gadgetboxt = $1 - 1
		end	
		if player.ableacc == nil
			player.ableacc = true
		end
			if player.mo.state == S_SCOOTER_STAND //Scooter states
				if not S_SoundPlaying(player.mo, sfx_scostd)
					S_StartSound(player.mo, sfx_scostd)
				end
				player.ableacc = true
			else
				if S_SoundPlaying(player.mo, sfx_scostd)
					S_StopSoundByID(player.mo, sfx_scostd)
				end
			end
			if player.mo.state == S_SCOOTER_RUN
				if not S_SoundPlaying(player.mo, sfx_scoacc)
				and player.ableacc == true
					S_StartSound(player.mo, sfx_scoacc)
					player.ableacc = false				
				end
				if player.ableacc == false
				and not S_SoundPlaying(player.mo, sfx_scoacc)
					if not S_SoundPlaying(player.mo, sfx_scomov)
						S_StartSound(player.mo, sfx_scomov)
					end	
				end
			else
				if S_SoundPlaying(player.mo, sfx_scomov)
					S_StopSoundByID(player.mo, sfx_scomov)
				end
				if S_SoundPlaying(player.mo, sfx_scoacc)
					S_StopSoundByID(player.mo, sfx_scoacc)
				end
			end
		if player.firecd == nil
			player.firecd = 0
		end
		if player.firecd > 0
			player.firecd = $1 - 1
		end	
		if player.tptimer == nil
			player.tptimer = false
		end	
		if player.abletele == nil
			player.abletele = true
		end
		if player.float == nil
			player.float = 0
		end
		local inverter
		if player.ginv == true
		and not G_EnoughPlayersFinished()
			if (inverter == nil or not inverter)
			and player.hasinv != true
				inverter = P_SpawnMobj(player.mo.x, player.mo.y, player.mo.z, MT_INVERTER)
				inverter.guywhoinv = player.mo
			end
			if player.mo.eflags & MFE_GOOWATER
				player.mo.eflags = $ & ~MFE_VERTICALFLIP
				player.mo.flags2 = $ & ~MF2_OBJECTFLIP
				player.invg = false
				if player.mo.eflags & MFE_VERTICALFLIP
					player.invert = true
				end	
			end
			player.hasinv = true
		else
			if inverter
				P_KillMobj(inverter)
			end
			player.hasinv = false
		end	
		if player.invert == nil
			player.invert = false
		end
		if player.cmd.buttons & BT_CUSTOM2
		and not player.distraction
		and not G_EnoughPlayersFinished()
			if player.custom2 == false //G-Inverter
			and player.ginv == true
			and P_IsObjectOnGround(player.mo)
				if player.mo.eflags & MFE_VERTICALFLIP
					player.mo.eflags = $ & ~MFE_VERTICALFLIP
					player.mo.flags2 = $ & ~MF2_OBJECTFLIP
					player.invg = false
					player.invert = true
				else
					player.mo.eflags = $|MFE_VERTICALFLIP
					player.mo.flags2 = $|MF2_OBJECTFLIP
					player.invg = true
					player.invert = true
				end
				player.mo.state = S_PLAY_FALL
			end
			player.custom2 = true
		else
			player.custom2 = false
		end
		if player.tpx == nil
			player.tpx = 0
		end
		if player.tpy == nil
			player.tpy = 0
		end
		if player.tpz == nil
			player.tpz = 0
		end
		if player.mo.chancetime == nil
			player.mo.chancetime = 0
		end 
		if player.cmd.buttons & BT_SPIN //Some shit on spin button
		and not player.distraction
		and not G_EnoughPlayersFinished()
			if player.spin == false //gun
			and player.gadgetbox == false
			and player.scooter == false
			and player.teleporter == false
			//and player.jetpack == false
			and not (player.powers[pw_carry] == CR_ZOOMTUBE)
			and player.firecd <= 0
			and not (player.powers[pw_carry] == CR_PLAYER)
				S_StartSound(player.mo, sfx_gunfir)
				player.drawangle = player.mo.angle
				player.mo.frame = A
				player.pflags = $|PF_FULLSTASIS
				player.firecd = 5
				if P_IsObjectOnGround(player.mo)
					if player.speed < 5*FRACUNIT
						player.mo.state = S_PLAY_FIRE
					else
						player.mo.state = S_PLAY_AIRFIRE1
						player.mo.momz = 5*FRACUNIT
					end	
				else
					player.mo.state = S_PLAY_AIRFIRE1
				end
				if player.bot != 1
					P_SpawnPlayerMissile(player.mo, MT_BULLET)
				else
					player.target = P_LookForEnemies(player, false, true)
					if player.target
						P_SpawnMissile(player.mo, player.target, MT_BULLET)
					else
						P_SpawnPlayerMissile(player.mo, MT_BULLET)
					end	
				end
			end	
			if player.spin == false //Teleporter
			and player.teleporter == true
			and P_IsObjectOnGround(player.mo)
			and player.abletele == true
				if not (player.mo.state == S_PLAY_TPSTART1
				or player.mo.state == S_PLAY_TPEND1
				or player.mo.state == S_PLAY_TPSTART2
				or player.mo.state == S_PLAY_TPEND2
				or player.mo.state == S_PLAY_TPSTART3
				or player.mo.state == S_PLAY_TPEND3
				or player.mo.state == S_PLAY_TPSTART4
				or player.mo.state == S_PLAY_TPEND4
				or player.mo.state == S_PLAY_TPSTART5
				or player.mo.state == S_PLAY_TPEND5)
					player.mo.state = tpstart[randomtpstate]
					player.tptimer = 0
					player.tpx = player.mo.x
					player.tpy = player.mo.y
					player.tpz = player.mo.z
				end	
				if player.mo.state == S_PLAY_TPSTART1
					S_StartSound(player.mo, sfx_telas)
				end
				if player.mo.state == S_PLAY_TPSTART2
					S_StartSound(player.mo, sfx_telbs)
				end
				if player.mo.state == S_PLAY_TPSTART3
					S_StartSound(player.mo, sfx_telcs)
				end
				if player.mo.state == S_PLAY_TPSTART4
					S_StartSound(player.mo, sfx_telds)
				end
				if player.mo.state == S_PLAY_TPSTART5
					S_StartSound(player.mo, sfx_teles)
				end
			end
			player.spin = true
		else
			player.spin = false
		end
		if player.mo.frame & FF_FRAMEMASK == A //Teleporter sounds
		and player.stopstate == false
			if player.mo.state == S_PLAY_TPEND1
				S_StartSound(player.mo, sfx_telae)
			end
			if player.mo.state == S_PLAY_TPEND2
				S_StartSound(player.mo, sfx_telbe)
			end
			if player.mo.state == S_PLAY_TPEND3
				S_StartSound(player.mo, sfx_telce)
			end
			if player.mo.state == S_PLAY_TPEND4
				S_StartSound(player.mo, sfx_telde)
			end
			if player.mo.state == S_PLAY_TPEND5
				S_StartSound(player.mo, sfx_telee)
			end
		end
		if (player.mo.state == S_PLAY_TPEND1
		or player.mo.state == S_PLAY_TPEND2
		or player.mo.state == S_PLAY_TPEND3
		or player.mo.state == S_PLAY_TPEND4
		or player.mo.state == S_PLAY_TPEND5)
			if (player.mo.frame & FF_FRAMEMASK == B) //Stop state
				player.stopstate = true
			end
			if player.mo.frame & FF_FRAMEMASK == A //Stop state
				if player.stopstate == true
					player.mo.state = S_PLAY_STND
					player.stopstate = false
				end
			end
		end
			if player.mo.state == S_PLAY_TPSTART1 //Teleporting
			or player.mo.state == S_PLAY_TPEND1
			or player.mo.state == S_PLAY_TPSTART2
			or player.mo.state == S_PLAY_TPEND2
			or player.mo.state == S_PLAY_TPSTART3
			or player.mo.state == S_PLAY_TPEND3
			or player.mo.state == S_PLAY_TPSTART4
			or player.mo.state == S_PLAY_TPEND4
			or player.mo.state == S_PLAY_TPSTART5
			or player.mo.state == S_PLAY_TPEND5
				player.pflags = $|PF_FULLSTASIS
			end	
		//Teleport	
				if (player.mo.state == S_PLAY_TPSTART1
				or player.mo.state == S_PLAY_TPSTART2
				or player.mo.state == S_PLAY_TPSTART3
				or player.mo.state == S_PLAY_TPSTART4
				or player.mo.state == S_PLAY_TPSTART5)
					local randomtype = P_RandomRange(1, 2)
					local randomtypechance = P_RandomRange(1,100)
					local randomtpstate = P_RandomRange(1, 5)
					if (player.mo.frame & FF_FRAMEMASK == B) 
						player.tptimer = true
					end
					if player.mo.frame & FF_FRAMEMASK == A 
						if player.tptimer == true
							player.tptimer = false
							player.mo.state = tpend[randomtpstate]
							if randomtypechance > 50
								local randX = P_RandomRange(1028, 4096)
								local randY = P_RandomRange(1028, 4096)
								
								//randomly flip the numbers
								//yes this isn't pretty but shh
								if (P_RandomRange(0, 1)) then
									randX = -$1
								end
								
								if (P_RandomRange(0, 1)) then
									randY = -$1
								end
								
								local randZ = P_RandomRange(-256, 512)
								P_TeleportMove(player.mo, player.mo.x+randX*FRACUNIT, player.mo.y+randY*FRACUNIT, player.mo.z+randZ*FRACUNIT)
								player.abletele = false
							end
							if randomtypechance <= 50 and randomtypechance > 25
								if (starpostList[1])
								and not (P_RandomRange(0, 3)) then
									local starpost = starpostList[P_RandomRange(1, table.maxn(starpostList))]
									if starpost.valid
										local modX = FixedMul(cos(starpost.angle+ANGLE_90), 64*FRACUNIT)
										local modY = FixedMul(sin(starpost.angle+ANGLE_90), 64*FRACUNIT)
											
										if not (P_RandomRange(0, 1)) then
											modX,modY = -$1, -$2
										end
											
										local teleX = starpost.x + modX
										local teleY = starpost.y + modY
										player.mo.angle = starpost.angle
										player.drawangle = starpost.angle
										P_TeleportMove(player.mo, teleX, teleY, starpost.z)
										player.abletele = false
									end	
								end	
							end
							if randomtypechance <= 25
								if (skymapList[1])
									local skymap = skymapList[P_RandomRange(1, table.maxn(skymapList))]
									if skymap.valid
										local modX = FixedMul(cos(skymap.angle+ANGLE_90), 64*FRACUNIT)
										local modY = FixedMul(sin(skymap.angle+ANGLE_90), 64*FRACUNIT)
													
										if not (P_RandomRange(0, 1)) then
											modX,modY = -$1, -$2
										end
													
										local teleX = skymap.x + modX
										local teleY = skymap.y + modY
										player.mo.angle = skymap.angle
										player.drawangle = skymap.angle
										P_TeleportMove(player.mo, teleX, teleY, skymap.z)
										player.abletele = true
									end
								end	
							end	
							local disttp = R_PointToDist2(player.mo.x, player.mo.y, player.tpx, player.tpy)
							if disttp < 1024*FRACUNIT
								local randX = P_RandomRange(1028, 4096)
								local randY = P_RandomRange(1028, 4096)
								
								//randomly flip the numbers
								//yes this isn't pretty but shh
								if (P_RandomRange(0, 1)) then
									randX = -$1
								end
								
								if (P_RandomRange(0, 1)) then
									randY = -$1
								end
								
								local randZ = P_RandomRange(-256, 512)
								P_TeleportMove(player.mo, player.mo.x+randX*FRACUNIT, player.mo.y+randY*FRACUNIT, player.mo.z+randZ*FRACUNIT)
								player.abletele = false
							end
							player.teleporter = false
						end	
					end
				end		
		
		if player.gitem == nil
			player.gitem = 0
		end
		if player.gitem > 4
			player.gitem = 0
		end
		if R_PointInSubsectorOrNil(player.mo.x, player.mo.y) == nil //Teleporter stuck in a wall thing
		and not player.powers[pw_carry] == CR_ZOOMTUBE
			P_DamageMobj(player.mo, nil, nil, DMG_INSTAKILL)
			player.failwhy = "You just can't seem to get"
			player.failwhy2 = "the hang of that thing can you?"
		end
		if player.cmd.buttons & BT_CUSTOM1 //Gadget box opening and closing
		and P_IsObjectOnGround(player.mo)
		and not G_EnoughPlayersFinished()
		and not player.distraction
			player.aimangle = player.mo.angle
			player.aimangle2 = player.aiming
			if player.c1 == false
				if player.jetpack == false and player.scooter == false and player.teleporter == false and player.ginv == false
					if player.gadgetbox == false
						player.gadgetbox = true
						S_FadeMusic(0, 1, player)
					else
						player.gadgetbox = false
						player.jumpfactor = skins[player.mo.skin].jumpfactor
						S_FadeMusic(100, 1, player)
						player.mo.state = S_PLAY_STND	
					end
				else
					player.jetpack = false
					if player.scooter == true
						player.scooter = false
						player.charflags = $ & ~(SF_RUNONWATER|SF_CANBUSTWALLS)
						local ghost = P_SpawnGhostMobj(player.mo)
						ghost.state = S_SCOOTER_BYE1
						ghost.angle = player.drawangle
						ghost.flags = $ & ~(MF_SOLID|MF_NOCLIP|MF_NOCLIPHEIGHT|MF_NOBLOCKMAP|MF_NOGRAVITY)
						P_InstaThrust(ghost, player.drawangle-ANGLE_90-ANGLE_45, 5*FRACUNIT)
						ghost.fuse = 150
					end	
					player.teleporter = false
					if P_IsObjectOnGround(player.mo)
					and player.invg == false
						player.ginv = false
						player.invg = false
					end
					player.normalspeed = skins[player.mo.skin].normalspeed
					player.runspeed = skins[player.mo.skin].runspeed
					player.charability = CA_NONE
					player.jumpfactor = skins[player.mo.skin].jumpfactor
					//player.followitem = MT_NULL
					if player.mo.state == S_SCOOTER_RUN
						if player.speed >= player.runspeed
							player.mo.state = S_PLAY_RUN
						else
							player.mo.state = S_PLAY_WALK
						end
					end
					if player.mo.state == S_SCOOTER_PAIN
						player.mo.state = S_PLAY_PAIN
					end
					if player.mo.state == S_SCOOTER_STAND
						player.mo.state = S_PLAY_STND
					end
					if player.mo.state == S_SCOOTER_JUMP
						player.mo.state = S_PLAY_JUMP
					end
				end	
			end
			player.c1 = true
		else
			player.c1 = false
		end
	end	
	if G_EnoughPlayersFinished()
			player.charflags = $ & ~(SF_RUNONWATER|SF_CANBUSTWALLS)
			player.falltodoom = false
			player.jumpfactor = skins[player.mo.skin].jumpfactor
			player.abletele = true
			player.failwhy = nil
			player.failwhy2 = nil
			player.failwhy3 = nil
			player.failwhy4 = nil
			player.failwhy5 = nil
			player.failwhy6 = nil
			player.failwhy7 = nil
			player.failwhy8 = nil
			player.failwhy9 = nil
			player.failwhy10 = nil
			player.jetpack = false
			player.scooter = false
			player.teleporter = false
			player.jetboost = 70
			player.randomfail = 1
			player.ginv = false
			player.gadgetbox = false
			player.failscreen = 0
			player.normalspeed = skins[player.mo.skin].normalspeed
			player.runspeed = skins[player.mo.skin].runspeed
			player.charability = CA_NONE
			//player.followitem = skins[player.mo.skin].followitem
			if player.mo.state == S_SCOOTER_RUN
				if player.speed >= player.runspeed
					player.mo.state = S_PLAY_RUN
				else
					player.mo.state = S_PLAY_WALK
				end
			end
			if player.mo.state == S_SCOOTER_PAIN
				player.mo.state = S_PLAY_PAIN
			end
			if player.mo.state == S_SCOOTER_STAND
				player.mo.state = S_PLAY_STND
			end
			if player.mo.state == S_SCOOTER_JUMP
				player.mo.state = S_PLAY_JUMP
			end
	end
	if player.mo.skin == "henry" //Mostly when you are dead
		//print(player.failwhy)
		if player.falltodoom == nil
			player.falltodoom = false
		end	
		if player.failscreen == nil
			player.failscreen = 0
		end
		if player.playerstate == PST_DEAD
			player.failscreen = $1 + 1
		end	
		if not P_IsObjectOnGround(player.mo)
			player.airmomz = player.mo.momz
		end
		if player.falltodoom == true
			player.mo.state = S_PLAY_PAIN
			player.mo.rollangle = $1 + player.mo.momz/FRACUNIT*ANG1
			player.drawangle = $1 + player.mo.momz/FRACUNIT*ANG1
			player.failwhy = "You're lucky! I've always wanted to go to space!"
		end
		local s = player.mo
		if s.subsector and s.subsector.sector
		and ( ((s.eflags & MFE_VERTICALFLIP) and ((s.subsector.sector.ceilingpic == "F_SKY1") or not s.subsector.sector.ceilingpic)) )
		and ((s.z+s.height) >= (s.subsector.sector.ceilingheight-5*FRACUNIT))
		and player.falltodoom == false
			P_DamageMobj(s, nil, nil, DMG_INSTAKILL)
			player.playerstate = PST_DEAD
			player.deadtimer = 0
			player.mo.momz = player.airmomz/2
			player.mo.flags = $|MF_NOCLIP|MF_NOCLIPHEIGHT|MF_NOBLOCKMAP
			s.state = S_PLAY_PAIN
			player.falltodoom = true
		end
	end	
end)

addHook("PlayerSpawn", function(player) //reset shit when respawning or spawning
	if player.mo.skin == "henry"
		player.charflags = $ & ~(SF_RUNONWATER|SF_CANBUSTWALLS)
		player.falltodoom = false
		player.jumpfactor = skins[player.mo.skin].jumpfactor
		player.abletele = true
		player.failwhy = nil
		player.failwhy2 = nil
		player.failwhy3 = nil
		player.failwhy4 = nil
		player.failwhy5 = nil
		player.failwhy6 = nil
		player.failwhy7 = nil
		player.failwhy8 = nil
		player.failwhy9 = nil
		player.failwhy10 = nil
		player.jetpack = false
		player.scooter = false
		player.teleporter = false
		player.jetboost = 70
		player.randomfail = 1
		player.ginv = false
		player.gadgetbox = false
		player.failscreen = 0
		player.normalspeed = skins[player.mo.skin].normalspeed
		player.runspeed = skins[player.mo.skin].runspeed
		player.charability = CA_NONE
		//player.followitem = skins[player.mo.skin].followitem
		if player.mo.state == S_SCOOTER_RUN
			if player.speed >= player.runspeed
				player.mo.state = S_PLAY_RUN
			else
				player.mo.state = S_PLAY_WALK
			end
		end
		if player.mo.state == S_SCOOTER_PAIN
			player.mo.state = S_PLAY_PAIN
		end
		if player.mo.state == S_SCOOTER_STAND
			player.mo.state = S_PLAY_STND
		end
		if player.mo.state == S_SCOOTER_JUMP
			player.mo.state = S_PLAY_JUMP
		end
		//player.failwhy = "You just respawned!"
	end
end)


addHook("MobjDeath", function(mo, inflictor, source, damagetype) //Fail screen
	if mo.skin == "henry"
	and mo.valid and not (mo.player.powers[pw_carry] == CR_NIGHTSMODE)
	and mo.player.failscreen <= 0
		P_FlashPal(mo.player, 1, 1*TICRATE/5)
		mo.player.failscreen = 0
	end	
end, MT_PLAYER)

addHook("TouchSpecial" ,function(mobj, mo)
	if mobj.valid
	and mobj.used != mo
		if mo.valid
			mo.player.abletele = true
			mobj.used = mo
		end
	end
end, MT_STARPOST)

freeslot("S_GDOWN", "S_GUP", "S_INVERTUP1", "S_INVERTDOWN1", "S_INVERTUP2", "S_INVERTDOWN2", "S_INVERTUP3", "S_INVERTDOWN3")

local function Jetpackthinker(mo)
		if mo.jetpacker and mo.jetpacker.valid
				local jetpack = mo
				local player = mo.jetpacker.player
				local jetx = player.mo.x+FixedMul(-12*FRACUNIT, cos(player.drawangle))
				local jety = player.mo.y+FixedMul(-12*FRACUNIT, sin(player.drawangle))
				mo.scale = FRACUNIT - FRACUNIT/5 - FRACUNIT/15
				if player.powers[pw_carry]
					player.pflags = $ & ~PF_THOKKED
					player.flyjet = 0
					player.jetboost = 70
				end
				if player.mo.eflags & MFE_VERTICALFLIP
					mo.eflags = $|MFE_VERTICALFLIP
					mo.flags2 = $|MF2_OBJECTFLIP
					if player.mo.state != S_PLAY_RIDE
						P_TeleportMove(mo, jetx, jety, (player.mo.z+40*FRACUNIT))
					else
						P_TeleportMove(mo, jetx, jety, player.mo.z-(player.mo.height-120*FRACUNIT))
					end	
				else
					mo.eflags = $ & ~MFE_VERTICALFLIP
					mo.flags2 = $ & ~MF2_OBJECTFLIP
					if player.mo.state != S_PLAY_RIDE
						P_TeleportMove(mo, jetx, jety, player.mo.z)
					else
						P_TeleportMove(mo, jetx, jety, player.mo.z-player.mo.height+30*FRACUNIT)
					end	
				end
				if player.flyjet > 0
					if mo.state != S_JETPACKFLY1 and mo.state != S_JETPACKFLY2
						mo.state = S_JETPACKFLY1
					end	
				else
					if mo.state != S_JETPACKIDLE
						mo.state = S_JETPACKIDLE
					end	
				end
				if P_IsObjectOnGround(mo.jetpacker) or (player.mo.eflags & MFE_UNDERWATER)
					if mo.state != S_JETPACKIDLE
						mo.state = S_JETPACKIDLE
					end	
				end
				mo.angle = player.drawangle
				mo.target = player.mo
				if jetpack
					jetpack.rollangle = player.mo.rollangle
				end
				if not P_IsObjectOnGround(player.mo)
					if player.nope == 0 or player.jetboost >= player.randomfail
						jetpack.colorized = false
						jetpack.color = player.mo.color
					end	
				end
				if player.jetboost <= player.randomfail+15
				and player.failjet != true
				and not P_IsObjectOnGround(player.mo)
					if jetpack
						if not S_SoundPlaying(jetpack, sfx_jetfal)
							S_StartSound(jetpack, sfx_jetfal)
						end	
						if (leveltime%10) == 1
							local exp = P_SpawnMobj(jetpack.x, jetpack.y, jetpack.z+jetpack.height/2, MT_EXPLODE)
							exp.jetpacker = jetpack
							S_StartSound(exp, sfx_cybdth)
						end	
					end	
				end
				if mo.jetpacker.state == S_PLAY_DISTRACTION or  mo.jetpacker.state == S_PLAY_THINK
					mo.flags2 = $|MF2_DONTDRAW
				else
					mo.flags2 = $ & ~MF2_DONTDRAW
				end
				if player.nope > 0 //Flashing after unsecsesful jet boost
					player.nope = $1 - 1
					if jetpack
						if (leveltime%5) <= 2
							jetpack.colorized = true
							jetpack.color = SKINCOLOR_RED
						else
							jetpack.colorized = false
							jetpack.color = player.mo.color
						end
					end	
				end
				local camdist = R_PointToDist(mo.x, mo.y)
				if player.jetpack != true or camdist <= 15*FRACUNIT or player.mo.skin != "henry"
					mo.flags2 = MF2_DONTDRAW
					mo.flags = MF_NOTHINK
					if camdist > 15*FRACUNIT
						local ghost = P_SpawnGhostMobj(mo)
						ghost.fuse = 50
						P_SetObjectMomZ(ghost, -5*FRACUNIT)
						P_InstaThrust(ghost, ghost.angle, -5*FRACUNIT)
						ghost.state = S_JETPACKFLY1
					end	
					player.hasjet = false
				end
		end	
end

local function Explodethinker(mo)
	if mo.jetpacker and mo.jetpacker.valid
		local player = mo.jetpacker.player
		mo.momx = mo.jetpacker.momx
		mo.momy = mo.jetpacker.momy
		mo.momz = mo.jetpacker.momz
		P_TeleportMove(mo, mo.jetpacker.x,  mo.jetpacker.y, mo.jetpacker.z)
	end	
end

local function Inverterthinker(mo)
		if mo.float == nil
			mo.float = 0
		end
		if mo.anglethingforfloat == nil
			mo.anglethingforfloat = 0
		end
		if mo.guywhoinv and mo.guywhoinv.valid
			local player = mo.guywhoinv.player
			local gotox = mo.guywhoinv.x + FixedMul(15*FRACUNIT, cos(player.drawangle+ANGLE_180+ANGLE_45))
			local gotoy = mo.guywhoinv.y + FixedMul(15*FRACUNIT, sin(player.drawangle+ANGLE_180+ANGLE_45))
			mo.anglethingforfloat = $1 + 1
			mo.float = FRACUNIT+FixedMul(sin(mo.anglethingforfloat*ANG1), FRACUNIT*5)
			if player.invert == true
				if mo.guywhoinv.eflags & MFE_VERTICALFLIP
					mo.state = S_INVERTDOWN1
					S_StartSound(mo, sfx_ginrtn)
				else
					mo.state = S_INVERTUP1
					S_StartSound(mo, sfx_gininv)
				end
				player.invert = false
			end
			if player.mo.eflags & MFE_VERTICALFLIP
				P_TeleportMove(mo, gotox, gotoy, (mo.guywhoinv.z - mo.guywhoinv.height - mo.height) + mo.float)
				//if mo.state != S_INVERTDOWN1 or mo.state != S_INVERTDOWN2 or mo.state != S_INVERTDOWN3
				//or mo.state != S_INVERTUP1 or mo.state != S_INVERTUP2 or mo.state != S_INVERTUP3
				//	mo.state = S_GUP
				//end
			else
				P_TeleportMove(mo, gotox, gotoy, (mo.guywhoinv.z + mo.guywhoinv.height) + mo.float)
				//if mo.state != S_INVERTDOWN1 or mo.state != S_INVERTDOWN2 or mo.state != S_INVERTDOWN3
				//or mo.state != S_INVERTUP1 or mo.state != S_INVERTUP2 or mo.state != S_INVERTUP3
				//	mo.state = S_GDOWN
				//end
			end
			if (player.hasinv == false or player.mo.skin != "henry") and player.visibleinverter != "false"
				local ghost = P_SpawnGhostMobj(mo)
				ghost.colorized = true
				ghost.color = SKINCOLOR_PURPLE
				P_KillMobj(mo)
				player.hasinv = false
			end
		end
end

local function Ghostthinker(mo)
	if mo.type == MT_GHOST
		if mo.state == S_JETPACKFLY1 or mo.state == S_JETPACKFLY2 or (mo.state == S_JETPACKIDLE and mo.eflags & MFE_UNDERWATER)
			P_SetObjectMomZ(mo, 1*FRACUNIT, true)
			if mo.eflags & MFE_UNDERWATER
				mo.state = S_JETPACKIDLE
			end
		end
		if mo.state == S_SCOOTER_BYE2
			P_Thrust(mo, mo.angle, 1*FRACUNIT)
		end
	end
end

addHook("MobjThinker", Ghostthinker, MT_GHOST)
addHook("MobjThinker", Jetpackthinker, MT_JETPACK)
addHook("MobjThinker", Explodethinker, MT_EXPLODE)
addHook("MobjThinker", Inverterthinker, MT_INVERTER)

addHook("MobjMoveCollide", function(mo, enemy)
    if mo.valid and mo.skin == "henry"
	and mo.player.speed >= mo.player.runspeed
	and mo.player.scooter == true
    and (enemy.flags & MF_ENEMY or enemy.flags & MF_BOSS or enemy.flags & MF_MONITOR or enemy.type == MT_SPIKE)
		if (enemy.z >= (mo.z - 16*FRACUNIT)) and (enemy.z <= (mo.z + mo.height + 16*FRACUNIT))
			if enemy.type == MT_SPIKE
				P_KillMobj(enemy, mo, mo)
			else
				P_DamageMobj(enemy, mo, mo)
			end
			local ram = P_SpawnMobj(mo.x, mo.y, mo.z, MT_THOK)
			ram.state = S_TNTBARREL_EXPL1
			mo.player.powers[pw_flashing] = 5
			S_StartSound(mo, sfx_mspogo)
			mo.chancetime = $ + 15
		elseif (enemy.flags2 & MF2_OBJECTFLIP)
		and (enemy.z <= (mo.z - 16*FRACUNIT)) and (enemy.z >= (mo.z + mo.height+ 16*FRACUNIT))
			if enemy.type == MT_SPIKE
				P_KillMobj(enemy, mo, mo)
			else
				P_DamageMobj(enemy, mo, mo)
			end
			P_DamageMobj(enemy, mo, mo)
			local ram = P_SpawnMobj(mo.x, mo.y, mo.z, MT_THOK)
			ram.state = S_TNTBARREL_EXPL1
			mo.player.powers[pw_flashing] = 5
			S_StartSound(mo, sfx_mspogo)
			mo.chancetime = $ + 15
        end
    end
end, MT_PLAYER)

addHook("ShouldDamage", function(mo, inf, sor, damage, damagetype)
	if mo.valid and mo.player and mo.skin == "henry"
	and not (mo.player.powers[pw_flashing] or mo.player.powers[pw_invulnerability])
		mo.player.gadgetbox = false
		mo.player.jumpfactor = skins[mo.skin].jumpfactor
		S_FadeMusic(100, 1, mo.player)
		return true
	end
end, MT_PLAYER)